import { DialogSOP } from '../../libappsop/dialogsop';
import { DropDownListSOP } from '../../libappsop/dropdownlistsop';

export interface DialogOptimizerFields {
  Puzzle?: string;
  Strategy?: string;
  HorizonStart?: string;
  HorizonEnd?: string;
}

export class DialogOptimizer extends DialogSOP<DialogOptimizerFields> {
  public readonly title = 'Optimizer';

  public ddlPuzzle = new DropDownListSOP('DropDownListPuzzle');
  public ddlStrategy = new DropDownListSOP('DropDownListStrategy');
  public ddlHorizonStart = new DropDownListSOP('DropDownListPeriodsFrom');
  public ddlHorizonEnd = new DropDownListSOP('DropDownListPeriodsTo');

  public constructor() {
    super('DialogRunOptimizer', 'btnOKRun');

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('Puzzle', this.ddlPuzzle);
    this._uiMap.set('Strategy', this.ddlStrategy);
    this._uiMap.set('HorizonStart', this.ddlHorizonStart);
    this._uiMap.set('HorizonEnd', this.ddlHorizonEnd);
  }
}
